package business;

import access.ProgramListenerMapTableDB;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import java.io.Serializable;


public class ProgramListenerMapTable implements Serializable
{
    private Hashtable htProgramMapper;

    public ProgramListenerMapTable()
    {
        System.out.println("CRETAED.........................");
        ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
        if( (htProgramMapper=objPLMTDB.retrieveMapTable()) == null)
        {
            System.out.println("HASH nEW");
            htProgramMapper = new Hashtable();
        }
        else
        {
   //         System.out.println("STAT PLMT TABLE  "+((ProgramListenerMapper)htProgramMapper.get("Test.java")));
           // System.out.println("LISTENER "+((ProgramListenerMapper)htProgramMapper.get("Test.java")).getListeners());

        }

    }

    public Vector getProgramNames()
    {
        Enumeration objEnum=htProgramMapper.keys();
        Vector vVector = null;
        if(objEnum.hasMoreElements()==true)
        {
            vVector = new Vector();
        }
        while(objEnum.hasMoreElements())
        {
            vVector.add(objEnum.nextElement());
        }
        return vVector;
    }
    public ProgramListenerMapper getProgramMapper(String sProgramName)
    {

        return (ProgramListenerMapper) htProgramMapper.get(sProgramName);
    }

    public  Vector[] getListeners(String sProgramName)
    {
        if(this.getProgramMapper(sProgramName)!=null)
            return this.getProgramMapper(sProgramName).getListeners();
        else{
            System.out.println("EEEEEEEEEEEE^^^^^^^^^^^");
            return null;
        }
    }



    public boolean registerProgram(String sProgramName)
    {
       ProgramListenerMapper objPLM = new ProgramListenerMapper();
       objPLM.setProgramName(sProgramName);
        System.out.println("HASH = "+htProgramMapper+" PLM :"+objPLM);
        System.out.println("Register sProgramName : " + sProgramName);
       htProgramMapper.put(sProgramName,objPLM);
       ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
       objPLMTDB.storeMapTable(htProgramMapper);

        return true;
    }

    public boolean unRegisterProgram(String sProgramName)
    {
       ProgramListenerMapper objPLM = getProgramMapper(sProgramName);

      System.out.println("unregister sProgramName : " + sProgramName);
       htProgramMapper.remove(objPLM);
        ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
        objPLMTDB.storeMapTable(htProgramMapper);

        return true;
    }

    public boolean registerProgramForListener(String sProgramName, ListenerInfo objLI)
    {

        ProgramListenerMapper objPLM = getProgramMapper(sProgramName);

        if(objPLM != null)
        {
            System.out.println("PLM inside registerProgramforListener" + objPLM);
            objPLM.addListener(objLI);
            ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
            objPLMTDB.storeMapTable(htProgramMapper);
            return true;
        }
        else
        {
            return false;
        }
    }

    public boolean unRegisterProgramForListener(String sProgramName, ListenerInfo objLI)
    {

        ProgramListenerMapper objPLM = getProgramMapper(sProgramName);
        if(objPLM != null)
        {
            System.out.println("PLM inside UnregisterProgramforListener" + objPLM);
            objPLM.removeListener(objLI);
            ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
            objPLMTDB.storeMapTable(htProgramMapper);
             return true;
         }
        else
        {
            return false;
        }

    }

    public void updateListenerInfo()
    {
        Enumeration objEnum = htProgramMapper.keys();

        while(objEnum.hasMoreElements())
        {
            ProgramListenerMapper objPLM=(ProgramListenerMapper) htProgramMapper.get((String) objEnum.nextElement());
            objPLM.getListeners();
        }
        ProgramListenerMapTableDB   objDB = new ProgramListenerMapTableDB();
        objDB.storeMapTable(htProgramMapper);
    }

}