
import query.Node;
import query.Parse;

import java.util.Vector;

import business.LSLTokens;
import business.SoundCallsLibrary;

//import jlisten.g1.auraliser.instrumentor.business.LSLTokens;
//import jlisten.g1.auraliser.instrumentor.business.SoundCallsLibrary;
//import jlisten.g1.auraliser.instrumentor.business.SoundCallsConstants;

public class Decorator
 {

    public Decorator()
    {

    }

    private int TokenPatchCode(LSLTokens objLslTokens)
    {
        String sKeyWord=objLslTokens.getKeyword();
        if(sKeyWord.equalsIgnoreCase("for_body_begin"))
            return 1;
        if(sKeyWord.equalsIgnoreCase("for_body_end"))
            return 2;
        if(sKeyWord.equalsIgnoreCase("while_body_begin"))
            return 3;
        if(sKeyWord.equalsIgnoreCase("while_body_end"))
            return 4;
        if(sKeyWord.equalsIgnoreCase("if_body_begin"))
            return 5;
        if(sKeyWord.equalsIgnoreCase("if_body_end"))
            return 6;
        if(sKeyWord.equalsIgnoreCase("do_while_body_begin"))
            return 7;
        if(sKeyWord.equalsIgnoreCase("do_while_body_end"))
            return 8;
        if(sKeyWord.equalsIgnoreCase("continue"))
            return 9;
        if(sKeyWord.equalsIgnoreCase("break"))
            return 10;
        if(sKeyWord.equalsIgnoreCase("method_call_begin"))
            return 11;
        if(sKeyWord.equalsIgnoreCase("method_call_end"))
            return 12;
        if(sKeyWord.equalsIgnoreCase("constructor"))
            return 13;
        if(sKeyWord.equalsIgnoreCase("dtrack"))
            return 14;
        if(sKeyWord.equalsIgnoreCase("atrack_method"))
            return 15;
        if(sKeyWord.equalsIgnoreCase("atrack_class"))
            return 16;
        if(sKeyWord.equalsIgnoreCase("finalize"))
            return 17;
        if(sKeyWord.equalsIgnoreCase("super"))
            return 18;
        if(sKeyWord.equalsIgnoreCase("finally"))
            return 19;
        if(sKeyWord.equalsIgnoreCase("synchronized_method_begin"))
            return 20;
        if(sKeyWord.equalsIgnoreCase("synchronized_method_end"))
            return 21;

        return -1;
    }


    public  Parse decorate(String sJavaFileName, String sJavaFilePath,Vector vLsLTokens)

    {
        SoundCallsLibrary objSoundCallsLibrary= new SoundCallsLibrary();
        Vector vpatches= objSoundCallsLibrary.getSoundCallPatches(sJavaFileName,vLsLTokens);
         System.out.println("File Path  "+sJavaFilePath);
        Parse objParse=new Parse(sJavaFilePath);


        Node objRoot=objParse.getRoot();
         if(objParse.getError() != null)
         {
             System.out.println("Error in Parsing");
             return null;
         }

        objRoot.getFirst().setAnnotation(objSoundCallsLibrary.getImportStatementPatches(sJavaFileName),null);
        System.out.println(objSoundCallsLibrary.getImportStatementPatches(sJavaFileName));
        TestConstructorPatch TCP = new TestConstructorPatch();
        TCP.patchConstructor(objRoot,objSoundCallsLibrary.getConstructorPatch(sJavaFileName));
       // TCP.patchFinalize(objRoot,objSoundCallsLibrary.getFinalizePatch(sJavaFileName));
        TCP.patchEndMain(objRoot,objSoundCallsLibrary.getFinalizePatch(sJavaFileName ));
        for(int iCount=0;iCount<vLsLTokens.size();iCount++)
        {


            LSLTokens objLslTokens=(LSLTokens)vLsLTokens.get(iCount);
            Scope objScope = new Scope();
            Vector vScopeNodes;
            String sPatch;
            switch(this.TokenPatchCode(objLslTokens))
            {
                case 1:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestForRec.annotate(objScopeNode,sPatch);
                    }
                    break;
                case 2:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestForRecAfter.annotate(objScopeNode,sPatch);
                    }
                    break;
                case 3:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestWhileRecBefore.annotate(objScopeNode,sPatch);
                    }
                    break;

                case 4:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestWhileRecAfter.annotate(objScopeNode,sPatch);
                    }
                    break;
                case 5:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestIFRecBefore.annotate(objScopeNode,sPatch);
                    }
                    break;
                case 6:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestIFRecAFter.annotate(objScopeNode,sPatch);
                    }
                    break;
                case 7:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestDORecBefore.annotate(objScopeNode,sPatch);
                    }
                    break;
                case 8:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestDORecAfter.annotate(objScopeNode,sPatch);
                    }
                    break;
                case 9:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
  Continue.annotate(objScopeNode,"{"+sPatch,"}");

                    }
                    break;
                case 10:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        Break.annotate(objScopeNode,"{"+sPatch,"}");
                    }
                    break;
                case 11:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        System.out.println("Insode For Loop");
                        TestForMethodCall.annotate(objScopeNode,objLslTokens.getIdentifier(),"{"+sPatch,"}",objLslTokens.getNoofParameters());
                    }
                    break;
                case 12:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        ForMethodCallAfter.annotate(objScopeNode,objLslTokens.getIdentifier(),"{",sPatch+"}",objLslTokens.getNoofParameters());
                    }
                    break;
                case 13:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        ConstructorBody.annotate(objScopeNode,objLslTokens.getIdentifier(),null,sPatch);
                    }
                    break;
                case 14:

                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {

                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        TestDtrack.annotate(objScopeNode,objLslTokens.getIdentifier(),"{",sPatch+"}");
                    }
                    break;
                case 15:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    Vector vPatches = (Vector)vpatches.get(iCount);
                    String sBeginPatch = (String)vPatches.get(0);
                    String sEndPatch = (String)vPatches.get(1);

                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        Activity.annotate(objScopeNode,objLslTokens.getIdentifier(),sBeginPatch,sEndPatch,-1);
                    }
                    break;
                case 16:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    Vector vPatchesCls = (Vector)vpatches.get(iCount);
                    String sBeginPatchCls = (String)vPatchesCls.get(0);
                    String sEndPatchCls = (String)vPatchesCls.get(1);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        ConstructorBody.annotate(objScopeNode,objLslTokens.getIdentifier(),null,sBeginPatchCls);
                        FinalizeMethod.annotate(objScopeNode,objLslTokens.getIdentifier(),null,sEndPatchCls);

                    }
                    break;
                case 17:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                        Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                        FinalizeMethod.annotate(objScopeNode,objLslTokens.getIdentifier(),null,sPatch);
                    }
                    break;
                    /*case 18:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    sPatch=(String)vpatches.get(iCount);
                    System.out.println(vpatches.get(iCount));
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                    Node objScopeNode = (Node)vScopeNodes.get(iIndex);
                    //TestForSync.annotate(objScopeNode,"\n{\n",sPatch+"\n}\n");
                    }
                    break;
                    case 19:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                    TestWhileRecAfter.annotate(objRoot,sPatch);
                    }
                    break;
                    case 20:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                    TestWhileRecAfter.annotate(objRoot,sPatch);
                    }break;
                    case 21:
                    vScopeNodes = objScope.getNodewithScope(objRoot,objLslTokens);
                    for(int iIndex = 0;iIndex < vScopeNodes.size();iIndex ++)
                    {
                    TestWhileRecAfter.annotate(objRoot,sPatch);
                    }
                    break;

                    */






            }





        }
        return objParse;
    }

   /* public static void main(String[] args) {

        Vector v1=new Vector();
        Vector v2=new Vector();
        TestRecMethod TRM = new TestRecMethod();
        Parse objparse = new Parse(args[0]);
        if(objparse.getError() != null)
        {
            System.err.println("error in Parsing");
        }

        v1.addElement(new String("While_Before"));
        v1.addElement(new String("IF_Before"));
        v2.addElement(new String("instrIFBefore()"));
        v2.addElement(new String("instrWHileBefore()"));
        clsDecorator obj1=new clsDecorator();
        obj1.decorate(v1,v2,objparse);



        TRM.fprintDecoratedCode(objparse);



    }
    */
}
